//+------------------------------------------------------------------+
//|                                                 TimeFuncions.mqh |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
//+------------------------------------------------------------------+
//|               |
//|                                           |
//+------------------------------------------------------------------+
bool LowerTFFirstBarTime(string aSymbol,ENUM_TIMEFRAMES aLowerTF,datetime aUpperTFBarTime,datetime  &aLowerTFFirstBarTime)
  {
   datetime tm[];
//---           
   if(CopyTime(aSymbol,aLowerTF,aUpperTFBarTime,1,tm)==-1)
     {
      return(false);
     }
   if(tm[0]<aUpperTFBarTime)
     {
      //---    
      datetime tm2[];
      //---      
      if(CopyTime(aSymbol,aLowerTF,0,1,tm2)==-1)
        {
         return(false);
        }
      if(tm[0]<tm2[0])
        {
         //---       
         //---     
         int start=Bars(aSymbol,aLowerTF,tm[0],tm2[0])-2;
         //---  Bars()  ,    ,
         //---      tm[0],  
         //---  2. 1    
         //---   tm[0]  1   
         //---  
         if(CopyTime(aSymbol,aLowerTF,start,1,tm)==-1)
           {
            return(false);
           }
        }
      else
        {
         //---      
         //---    
         aLowerTFFirstBarTime=0;
         return(true);
        }
     }
//---      
   aLowerTFFirstBarTime=tm[0];
   return(true);
  }
//+------------------------------------------------------------------+
//|            |
//|                                           |
//+------------------------------------------------------------------+
bool LowerTFLastBarTime(string aSymbol,ENUM_TIMEFRAMES aUpperTF,ENUM_TIMEFRAMES aLowerTF,datetime aUpperTFBarTime,datetime  &aLowerTFFirstBarTime)
  {
//---     
   datetime NextBarTime=aUpperTFBarTime+PeriodSeconds(aUpperTF);
   datetime tm[];
   if(CopyTime(aSymbol,aLowerTF,NextBarTime,1,tm)==-1)
     {
      return(false);
     }
   if(tm[0]==NextBarTime)
     {
      //---    
      //---    
      //---  .
      //---      
      datetime tm2[];
      if(CopyTime(aSymbol,aLowerTF,0,1,tm2)==-1)
        {
         return(false);
        }
      //---      
      int start=Bars(aSymbol,aLowerTF,tm[0],tm2[0]);
      //---    
      if(CopyTime(aSymbol,aLowerTF,start,1,tm)==-1)
        {
         return(false);
        }
     }
//---      
   aLowerTFFirstBarTime=tm[0];
   return(true);
  }
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
datetime BarTimeNormalize(datetime aTime,ENUM_TIMEFRAMES aTimeFrame)
  {
   int BarLength=PeriodSeconds(aTimeFrame);
   return(BarLength*(aTime/BarLength));
  }
//+------------------------------------------------------------------+
//|                     |
//| aTime -   ,                                        |
//| int  &aH, int  &aM, int  &aS -    s,        |
//| ,                                                   |
//+------------------------------------------------------------------+
int TimeFromDayStart(datetime aTime,int  &aH,int  &aM,int  &aS)
  {
//---       (aTime%86400) 
//---     ,   
   aH=(int)((aTime%86400)/3600);
//---        (aTime%3600) 
//---      ,    
   aM=(int)((aTime%3600)/60);
//---        
   aS=(int)(aTime%60);
//---     
   return(int(aTime%86400));
  }
//+------------------------------------------------------------------+
//|                       |
//| datetime aTime - ,                                          |
//| bool aStartsOnMonday=false -         |
//+------------------------------------------------------------------+
long WeekNum(datetime aTime,bool aStartsOnMonday=false)
  {
//---     ,
//---   4- ,
//---    - 3- 
   aTime+=86400*(4-aStartsOnMonday);
   return(aTime/604800);
  }
//+------------------------------------------------------------------+
//|                             |
//| datetime aTime - ,                                          |
//| bool aStartsOnMonday=false -         |
//+------------------------------------------------------------------+
long WeekStartTime(datetime aTime,bool aStartsOnMonday=false)
  {
   long tmp=aTime;
   long Corrector=86400*(4-aStartsOnMonday);
   tmp+=Corrector;
   tmp=(tmp/604800)*604800;
   tmp-=Corrector;
   return(tmp);
  }
//+------------------------------------------------------------------+
//|                  |
//| datetime aTime - ,                                          |
//| bool aStartsOnMonday=false -         |
//+------------------------------------------------------------------+
long SecondsFromWeekStart(datetime aTime,bool aStartsOnMonday=false)
  {
   return(aTime-WeekStartTime(aTime,aStartsOnMonday));
  }
//+------------------------------------------------------------------+
//|                      |
//| datetime aTime -      ,   |
//| datetime aStartTime -  ,                           |
//| bool aStartsOnMonday=false -         |
//+------------------------------------------------------------------+
long WeekNumFromDate(datetime aTime,datetime aStartTime,bool aStartsOnMonday=false)
  {
   long Time,StartTime,Corrector;
   MqlDateTime stm;
   Time=aTime;
   StartTime=aStartTime;
//---    
   StartTime=(StartTime/86400)*86400;
//---   
//---    
   Time-=StartTime;
//---      
   TimeToStruct(StartTime,stm);
//---     ,
//---      1, 
//---    0,     6
   if(aStartsOnMonday)
     {
      if(stm.day_of_week==0)
        {
         stm.day_of_week=6;
        }
      else
        {
         stm.day_of_week--;
        }
     }
//---     
   Corrector=86400*stm.day_of_week;
//---  
   Time+=Corrector;
//---     
   return(Time/604800);
  }
//+------------------------------------------------------------------+
//|                                       |
//| datetime aTime -                                            |
//+------------------------------------------------------------------+
datetime YearStartTime(datetime aTime)
  {
   MqlDateTime stm;
   TimeToStruct(aTime,stm);
   stm.day=1;
   stm.mon=1;
   stm.hour=0;
   stm.min=0;
   stm.sec=0;
   return(StructToTime(stm));
  }
//+------------------------------------------------------------------+
//|                                     |
//| datetime aTime -                                            |
//+------------------------------------------------------------------+
datetime MonthStartTime(datetime aTime)
  {
   MqlDateTime stm;
   TimeToStruct(aTime,stm);
   stm.day=1;
   stm.hour=0;
   stm.min=0;
   stm.sec=0;
   return(StructToTime(stm));
  }
//+------------------------------------------------------------------+
//|                               |
//| datetime aTime - ,                                          |
//| bool aStartsOnMonday=false -         |
//+------------------------------------------------------------------+
long WeekNumYear(datetime aTime,bool aStartsOnMonday=false)
  {
   return(WeekNumFromDate(aTime,YearStartTime(aTime),aStartsOnMonday));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
long WeekNumMonth(datetime aTime,bool aStartsOnMonday=false)
  {
   return(WeekNumFromDate(aTime,MonthStartTime(aTime),aStartsOnMonday));
  }
//+------------------------------------------------------------------+
//|                           |
//| datetime aTimeCur -  ,                               |
//| datetime aTimePre -  ,                            |
//+------------------------------------------------------------------+
bool NewDay1(datetime aTimeCur,datetime aTimePre)
  {
   return((aTimeCur/86400)!=(aTimePre/86400));
  }
//+------------------------------------------------------------------+
//|                    |
//|                                                       |
//| datetime aTimeCur -  ,                               |
//| datetime aTimePre -  ,                            |
//+------------------------------------------------------------------+
bool NewDay2(datetime aTimeCur,datetime aTimePre)
  {
   MqlDateTime stm;
//---  
   if(NewDay1(aTimeCur,aTimePre))
     {
      TimeToStruct(aTimeCur,stm);
      switch(stm.day_of_week)
        {
         case 6: // 
            return(false);
            break;
         case 0: // 
            return(true);
            break;
         case 1: // 
            TimeToStruct(aTimePre,stm);
            if(stm.day_of_week!=0)
              { //    
               return(true);
              }
            else
              {
               return(false);
              }
            break;
         default: //    
            return(true);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                       |
//| datetime aTimeCur -  ,                               |
//| datetime aTimePre -  ,                            |
//| int aVariant=1 - 1 -    , 2 -   |
//|                                            |
//+------------------------------------------------------------------+
bool NewDay(datetime aTimeCur,datetime aTimePre,int aVariant=1)
  {
   switch(aVariant)
     {
      case 1:
         return(NewDay1(aTimeCur,aTimePre));
         break;
      case 2:
         return(NewDay2(aTimeCur,aTimePre));
         break;
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                 |
//| int aStartHour -   ,                             |
//| int aStartMinute -   ,                        |
//| int aStopHour -   ,                           |
//| int aStopMinute -   ,                      |
//| datetime aTimeCur -                                  |
//+------------------------------------------------------------------+
bool TimeSession(int aStartHour,int aStartMinute,int aStopHour,int aStopMinute,datetime aTimeCur)
  {
//---   
   int StartTime=3600*aStartHour+60*aStartMinute;
//---   
   int StopTime=3600*aStopHour+60*aStopMinute;
//---       
   aTimeCur=aTimeCur%86400;
   if(StopTime<StartTime)
     {
      //---   
      if(aTimeCur>=StartTime || aTimeCur<StopTime)
        {
         return(true);
        }
     }
   else
     {
      //---   
      if(aTimeCur>=StartTime && aTimeCur<StopTime)
        {
         return(true);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|           |
//| int aHour -   ,                                      |
//| int aMinute -   ,                                 |
//| datetime aTimeCur -  ,                               |
//| datetime aTimePre -                               |
//+------------------------------------------------------------------+
bool TimeCross(int aHour,int aMinute,datetime aTimeCur,datetime aTimePre)
  {
//---     
   datetime PointTime=aHour*3600+aMinute*60;
//---     
   aTimeCur=aTimeCur%86400;
//---     
   aTimePre=aTimePre%86400;
   if(aTimeCur<aTimePre)
     {
      //---   
      if(aTimeCur>=PointTime || aTimePre<PointTime)
        {
         return(true);
        }
     }
   else
     {
      if(aTimeCur>=PointTime && aTimePre<PointTime)
        {
         return(true);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                |
//| int aHour -   ,                                      |
//| int aMinute -   ,                                 |
//| datetime aTimeCur -  ,                               |
//| datetime aTimePre -                               |
//+------------------------------------------------------------------+
bool NewCustomDay(int aHour,int aMinute,datetime aTimeCur,datetime aTimePre)
  {
   MqlDateTime stm;
   if(TimeCross(aHour,aMinute,aTimeCur,aTimePre))
     {
      TimeToStruct(aTimeCur,stm);
      if(stm.day_of_week==0 || stm.day_of_week==6)
        {
         return(false);
        }
      else
        {
         return(true);
        }
     }
   return(false);
  }

//+------------------------------------------------------------------+
//|    WeekDays_Check()                          |
//+------------------------------------------------------------------+
input bool Sunday    =  true; // 
input bool Monday    =  true; // 
input bool Tuesday   =  true; //  
input bool Wednesday =  true; // 
input bool Thursday  =  true; // 
input bool Friday    =  true; // 
input bool Saturday  =  true; // 

bool WeekDays[7];
//+------------------------------------------------------------------+
//|       WeekDays_Check()   |
//+------------------------------------------------------------------+
void WeekDays_Init()
  {
   WeekDays[0]=Sunday;
   WeekDays[1]=Monday;
   WeekDays[2]=Tuesday;
   WeekDays[3]=Wednesday;
   WeekDays[4]=Thursday;
   WeekDays[5]=Friday;
   WeekDays[6]=Saturday;
  }
//+------------------------------------------------------------------+
//|                                                 |
//| datetime aTime -    ,         |
//|                                             |
//+------------------------------------------------------------------+
bool WeekDays_Check(datetime aTime)
  {
   MqlDateTime stm;
   TimeToStruct(aTime,stm);
   return(WeekDays[stm.day_of_week]);
  }
//+------------------------------------------------------------------+
//|                      |
//| int aStartDay -    ,                       |
//| int aStartHour -   ,                              |
//| int aStartMinute -   ,                         |
//| int aStopDay -    ,                     |
//| int aStopHour -   ,                            |
//| int aStopMinute -   ,                       |
//| aTimeCur -           |
//|                                                               |
//+------------------------------------------------------------------+
bool WeekSession(int aStartDay,int aStartHour,int aStartMinute,int aStopDay,int aStopHour,int aStopMinute,datetime aTimeCur)
  {
//---      
   int StartTime=aStartDay*86400+3600*aStartHour+60*aStartMinute;
//---      
   int StopTime=aStopDay*86400+3600*aStopHour+60*aStopMinute;
//---       
   long TimeCur=SecondsFromWeekStart(aTimeCur,false);
   if(StopTime<StartTime)
     {
      //---    
      if(TimeCur>=StartTime || TimeCur<StopTime)
        {
         return(true);
        }
     }
   else
     {
      //---   
      if(TimeCur>=StartTime && TimeCur<StopTime)
        {
         return(true);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                           |
//| aTime - -                                               |
//+------------------------------------------------------------------+
bool LeapYear(datetime aTime)
  {
   MqlDateTime stm;
   TimeToStruct(aTime,stm);
//---  4   
   if(stm.year%4==0)
     {
      //---  100
      if(stm.year%100==0)
        {
         //---  400
         if(stm.year%400==0)
           {
            return(true);
           }
        }
      //---   100        
      else
        {
         return(true);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                      |
//| aTime - -                                               |
//+------------------------------------------------------------------+
int DaysInMonth(datetime aTime)
  {
   MqlDateTime stm;
   TimeToStruct(aTime,stm);
   if(stm.mon==2)
     {
      //--- 
      if(LeapYear(aTime))
        {
         //---     
         return(29);
        }
      else
        {
         //---     
         return(28);
        }
     }
   else
     {
      //---  
      return(31-((stm.mon-1)%7)%2);
     }
  }
//+------------------------------------------------------------------+
